Subject: Re: [PATCH 11/20] nbd: request_fn fixup

From: Jeff Garzik <[email-masked]>
Date: Tue, 12 Sep 2006 20:21:06 -0400

Jens Axboe wrote:
> Generally the block device rule is that once you are invoked due to an
> unplug (or whatever) event, it is the responsibility of the block device
> to run the queue until it's done. So if you bail out of queue handling
> for whatever reason (might be resource starvation in hard- or software),
> you must make sure to reenter queue handling since the device will not
> get replugged while it has requests pending. Unless you run into some
> software resource shortage, running of the queue is done
> deterministically when you know resources are available (ie an io
> completes). The device plugging itself is only ever done when you
> encounter a shortage outside of your control (memory shortage, for
> instance) _and_ you don't already have pending work where you can invoke
> queueing from again.

Or he could employ the blk_{start,stop}_queue() functions, if that model 
is easier for the driver (and brain).

	Jeff